Attribute VB_Name = "Module6"
Public Sub flash_calc(composition() As Double, t As Double, p As Double, vapor_y() As Double, liquid_x() As Double, vapor_frac As Double, eps As Double, max_itr As Integer)
   Dim i, j, N As Integer
   Dim zl, zv, error1, error2, error3, f, dfdv, hh As Double
   Dim ki() As Double
   Dim liq_fug() As Double
   Dim vap_fug() As Double
   N = nnn - 1
 On Error GoTo e1:
   ReDim ki(N)
   ReDim liq_fug(N)
   ReDim vap_fug(N)
   N = nnn
   For i = 0 To N - 1
       ki(i) = Pc(i) / p * Exp(5.37 * (1 + w(i)) * (1 - Tc(i) / t))
   Next i
   vapor_frac = 0.5
   error1 = 1
   j = 0
   While (error1 > eps) Or (error2 > eps) Or (error3 > eps)
    j = j + 1
    If (j > max_itr) Then GoTo moh
    f = 0
    dfdv = 0
    For i = 0 To N - 1
      If composition(i) <> 0 Then
          f = f + composition(i) * (ki(i) - 1) / (1 + vapor_frac * (ki(i) - 1))
          dfdv = dfdv - composition(i) * (ki(i) - 1) ^ 2 / (1 + vapor_frac * (ki(i) - 1)) ^ 2
      End If
    Next i
    vapor_frac = vapor_frac - f / dfdv
    If (vapor_frac < 0) Then vapor_frac = 0
    If (vapor_frac > 1) Then vapor_frac = 1
    For i = 0 To N - 1
        liquid_x(i) = composition(i) / (1 + vapor_frac * (ki(i) - 1))
        vapor_y(i) = ki(i) * liquid_x(i)
    Next i
    error1 = Abs(sum(liquid_x) - 1)
    error2 = Abs(sum(vapor_y) - 1)
    error3 = Abs(f / dfdv)
    Call normalize(liquid_x)
    Call normalize(vapor_y)
    Call SRK(liquid_x, p, t, liq_fug, 1)
    Call SRK(vapor_y, p, t, vap_fug, 2)
    For i = 0 To N - 1
      If composition(i) <> 0 Then ki(i) = liq_fug(i) / vap_fug(i)
    Next i
  Wend
moh:
  If ((vapor_frac = 0) Or (vapor_frac = 1)) Then
      Call array_assign(vapor_y, composition)
      Call array_assign(liquid_x, composition)
  End If
e1:
End Sub

