VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "Envelope"
   ClientHeight    =   9645
   ClientLeft      =   2175
   ClientTop       =   870
   ClientWidth     =   10965
   LinkTopic       =   "Form1"
   ScaleHeight     =   9645
   ScaleWidth      =   10965
   Begin VB.Frame Frame3 
      Caption         =   "Interpolation by Spline"
      Height          =   4215
      Left            =   2640
      TabIndex        =   5
      Top             =   5280
      Width           =   5055
      Begin MSFlexGridLib.MSFlexGrid MSFlexGrid3 
         Height          =   3495
         Left            =   360
         TabIndex        =   6
         Top             =   480
         Width           =   4215
         _ExtentX        =   7435
         _ExtentY        =   6165
         _Version        =   393216
         Cols            =   3
         AllowUserResizing=   3
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Dew Curve Table"
      Height          =   4095
      Left            =   5160
      TabIndex        =   3
      Top             =   240
      Width           =   4935
      Begin MSFlexGridLib.MSFlexGrid MSFlexGrid2 
         Height          =   3255
         Left            =   240
         TabIndex        =   4
         Top             =   480
         Width           =   4215
         _ExtentX        =   7435
         _ExtentY        =   5741
         _Version        =   393216
         Cols            =   3
         AllowUserResizing=   3
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Bubble Curve Table"
      Height          =   4095
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   4695
      Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
         Height          =   3255
         Left            =   240
         TabIndex        =   2
         Top             =   480
         Width           =   3975
         _ExtentX        =   7011
         _ExtentY        =   5741
         _Version        =   393216
         Cols            =   3
         AllowUserResizing=   3
      End
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Run"
      Height          =   615
      Left            =   1440
      TabIndex        =   0
      Top             =   4560
      Width           =   7095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()
Dim i, j, k As Integer
Dim z(2) As Double
Dim x(2) As Double
Dim y(2) As Double
Dim x1(10) As Double
Dim y1(10) As Double
Dim interp1() As Double
Dim p As Double
Dim v1 As Double
Dim v2 As Double
Dim v3 As Double
Dim p1 As Double
Dim t As Double
Dim t1 As Double
Dim t2 As Double
Dim dt1 As Double
Dim dt2 As Double
Dim t_bubble As Double
Dim t_dew As Double
Dim p_bub As Double
Dim p_dew As Double
Dim noo As Double
Dim temp1 As Double
Dim temp2 As Double
Dim bool1 As Boolean
Tc(0) = 190.7:   Pc(0) = 46.41: w(0) = 0.0115
Tc(1) = 305.43:  Pc(1) = 48.84: w(1) = 0.0986
Tc(2) = 568.6:   Pc(2) = 24.97: w(2) = 0.4018
z(0) = 0.1
z(1) = 0.15
z(2) = 0.75
nnn = 3
Form2.TChart1.Series(0).Title = "bubble"
Form2.TChart1.Series(1).Title = "dew"
Form2.TChart1.Series(2).Title = "interp"
v1 = 0.05
Form2.TChart1.Series(3).Title = "VF=0.05"
v2 = 0.3
Form2.TChart1.Series(4).Title = "VF=0.3"
v3 = 0.5
Form2.TChart1.Series(5).Title = "VF=0.5"
p = 2#
bool1 = True
p_bub = 2
p_dew = 2
t_dew = 412#
t_bubble = 163#
On Error GoTo erhand:
Call bubble_t(z, p, y, t_bubble, 0.001)
MSFlexGrid1.Row = 1
MSFlexGrid1.Col = 0
MSFlexGrid1.Text = Str(1)
MSFlexGrid1.Col = 1
MSFlexGrid1.Text = Str(Format(t_bubble - 273.15, "###.###"))
MSFlexGrid1.Col = 2
MSFlexGrid1.Text = Val(p)
p_dew = p
p_bub = p
Call dew_t(z, p, x, t_dew, 0.001)
MSFlexGrid2.Row = 1
MSFlexGrid2.Col = 0
MSFlexGrid2.Text = Str(1)
MSFlexGrid2.Col = 1
MSFlexGrid2.Text = Str(Format(t_dew - 273.15, "###.###"))
MSFlexGrid2.Col = 2
MSFlexGrid2.Text = Str(p)
t1 = t_bubble
t2 = t_dew
dt1 = 8
dt2 = 5
i = 1
On Error GoTo mohamad:
While (bool1)
    i = i + 1
    t1 = t1 + dt1
    Call Bubble(z, t1, y, p_bub, 0.00001)
    Call flash_calc(z, t1, p_bub, y, x, noo, 0.00001, 50)
    If (noo > 0.1) Then GoTo mohamad
    p1 = p_bub
    Call spec_flash(t1, v1, z, x, y, p1)
    If p1 <> 0 Then Form2.TChart1.Series(3).AddXY t1, p1, "", vbYellow
        p1 = p_bub
    Call spec_flash(t1, v2, z, x, y, p1)
    If p1 <> 0 Then Form2.TChart1.Series(4).AddXY t1, p1, "", vbBlack
        p1 = p_bub
    Call spec_flash(t1, v3, z, x, y, p1)
    If p1 <> 0 Then Form2.TChart1.Series(5).AddXY t1, p1, "", vbCyan
    MSFlexGrid1.Rows = i + 1
    MSFlexGrid1.Row = i
    MSFlexGrid1.Col = 0
    MSFlexGrid1.Text = Str(i)
    MSFlexGrid1.Col = 1
    MSFlexGrid1.Text = Str(Format(t1 - 273.15, "###.###"))
    MSFlexGrid1.Col = 2
    MSFlexGrid1.Text = Val(Format(p_bub, "00#.###"))
    Form2.TChart1.Series(0).AddXY t1, p_bub, "", vbBlue
Wend
mohamad:
k = 0
For j = i - 5 To i - 1
    MSFlexGrid1.Row = j
    MSFlexGrid1.Col = 2
    x1(k) = Val(MSFlexGrid1.Text)
    MSFlexGrid1.Col = 1
    y1(k) = Val(MSFlexGrid1.Text) + 273.15
    k = k + 1
Next j
i = 1
On Error GoTo mohamad2:
While (bool1)
    i = i + 1
    t2 = t2 + dt2
    Call Dew(z, t2, x, p_dew, 0.00001)
    Call flash_calc(z, t2, p_dew, y, x, noo, 0.00001, 50)
    If (noo < 0.9) Or (p_dew = 0) Then GoTo mohamad2
    MSFlexGrid2.Rows = i + 1
    MSFlexGrid2.Row = i
    MSFlexGrid2.Col = 0
    MSFlexGrid2.Text = Str(i)
    MSFlexGrid2.Col = 1
    MSFlexGrid2.Text = Str(Format(t2 - 273.15, "###.###"))
    MSFlexGrid2.Col = 2
    MSFlexGrid2.Text = Str(Format(p_dew, "00#.###"))
    Form2.TChart1.Series(1).AddXY t2, p_dew, "", vbRed
Wend
mohamad2:
For j = (i - 1) To (i - 6) Step -1
    If k > 10 Then Exit For
    MSFlexGrid2.Row = j
    MSFlexGrid2.Col = 2
    x1(k) = Val(MSFlexGrid2.Text)
    MSFlexGrid2.Col = 1
    y1(k) = Val(MSFlexGrid2.Text) + 273.15
    k = k + 1
Next j
ReDim interp1(10, 4)
Call spline(x1, y1, interp1, 1, 0, 0)

For i = 0 To 20
    temp1 = 0
    temp2 = (x1(5) - x1(4)) / 20
    For j = 3 To 0 Step -1
      temp1 = interp1(4, 3 - j) * (x1(4) + i * temp2 - x1(4)) ^ j + temp1
    Next j
    Form2.TChart1.Series(2).AddXY temp1, x1(4) + i * temp2, "", clgreen
    MSFlexGrid3.Rows = i + 2
    MSFlexGrid3.Row = i + 1
    MSFlexGrid3.Col = 0
    MSFlexGrid3.Text = Str(i + 1)
    MSFlexGrid3.Col = 1
    MSFlexGrid3.Text = Str(Format(temp1 - 273.15, "###.###"))
    MSFlexGrid3.Col = 2
    MSFlexGrid3.Text = Str(Format(x1(4) + i * temp2, "00#.###"))
Next i
Form2.Show
Exit Sub
erhand:
MsgBox "a numerical error has occured"
End Sub


Private Sub Form_Load()
With MSFlexGrid1
  .Row = 0
  .Col = 0
  .Text = "Index"
  .Col = 1
  .Text = "T (C)"
  .Col = 2
  .Text = "P (bar)"
End With
With MSFlexGrid2
  .Row = 0
  .Col = 0
  .Text = "Index"
  .Col = 1
  .Text = "T (C)"
  .Col = 2
  .Text = "P (bar)"
End With
With MSFlexGrid3
  .Row = 0
  .Col = 0
  .Text = "Index"
  .Col = 1
  .Text = "T (C)"
  .Col = 2
  .Text = "P (bar)"
End With

End Sub

