Attribute VB_Name = "Module4"
Public Sub root_find(rr, ss As Double, x1, x2, y1, y2 As Double)
   Dim delta As Double
   delta = rr * rr + 4 * ss
   If delta >= 0 Then
       x1 = (rr + delta ^ 0.5) / 2
       x2 = (rr - delta ^ 0.5) / 2
       y1 = 0
       y2 = 0
   Else
       x1 = rr / 2
       x2 = rr / 2
       y1 = (-delta) ^ 0.5 / 2
       y2 = -(-delta) ^ 0.5 / 2
   End If

End Sub
Public Sub bairstow(a() As Double, result1() As Double, result2() As Double)
   Dim b(), c() As Double
   Dim ds As Double
   Dim dr As Double
   Dim R As Double
   Dim s As Double
   Dim eps As Double
   Dim i, j, N, itr As Integer
     N = UBound(a)
     ReDim b(N)
     ReDim c(N)
     j = 0
     itr = 0
     R = 1
     s = 1
   While (N > 2)
     b(1) = 1
     itr = 0
     eps = 0.00001
     While ((Abs(b(1)) > eps) Or (Abs(b(0)) > eps)) And (itr < 1000)
       b(N) = a(N)
       b(N - 1) = a(N - 1) + R * b(N)
       For i = N To 2 Step -1
         b(i - 2) = a(i - 2) + R * b(i - 1) + s * b(i)
       Next
       c(N) = b(N)
       c(N - 1) = b(N - 1) + R * c(N)
       For i = N To 3 Step -1
         c(i - 2) = b(i - 2) + R * c(i - 1) + s * c(i)
       Next
       dr = (-c(2) * b(1) + c(3) * b(0)) / (c(2) * c(2) - c(1) * c(3))
       ds = (-c(2) * b(0) + c(1) * b(1)) / (c(2) * c(2) - c(3) * c(1))
       R = R + dr
       s = s + ds
       If itr > 1000 Then
         Exit Sub
         MsgBox "maximum iteration reached in bairstow"
       End If
       itr = itr + 1
     Wend
     For i = N To 2 Step -1
       a(i - 2) = b(i)
     Next i
     Call root_find(R, s, result1(j), result1(j + 1), result2(j), result2(j + 1))
     N = N - 2
     j = j + 2

   Wend
     If N = 2 Then
       Call root_find(-a(1) / a(2), -a(0) / a(2), result1(j), result1(j + 1), result2(j), result2(j + 1))
     Else
       result1(j) = -a(0) / a(1)
       result2(j) = 0
     End If
   '     messagebox 'An unexpected error has occured in bairstow.'
 
End Sub

